diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoDomainDefaults.h sogo-5.2.0/SoObjects/SOGo/SOGoDomainDefaults.h
--- sogo-5.0.1/SoObjects/SOGo/SOGoDomainDefaults.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoDomainDefaults.h	2021-08-18 21:35:57.000000000 +0200
@@ -66,6 +66,7 @@
 - (BOOL) mailKeepDraftsAfterSend;
 - (BOOL) mailAttachTextDocumentsInline;
 - (NSArray *) mailListViewColumnsOrder;
+- (BOOL) mailCertificateEnabled;
 
 - (BOOL) aclSendEMailNotifications;
 - (BOOL) appointmentSendEMailNotifications;
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoDomainDefaults.m sogo-5.2.0/SoObjects/SOGo/SOGoDomainDefaults.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoDomainDefaults.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoDomainDefaults.m	2021-08-18 21:35:57.000000000 +0200
@@ -322,6 +322,11 @@
   return [self stringArrayForKey: @"SOGoMailListViewColumnsOrder"];
 }
 
+- (BOOL) mailCertificateEnabled
+{
+  return [self boolForKey: @"SOGoMailCertificateEnabled"];
+}
+
 - (NSArray *) superUsernames
 {
   return [self stringArrayForKey: @"SOGoSuperUsernames"];
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoGCSFolder.m sogo-5.2.0/SoObjects/SOGo/SOGoGCSFolder.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoGCSFolder.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoGCSFolder.m	2021-08-18 21:35:57.000000000 +0200
@@ -1658,8 +1658,6 @@
                 {
                   if ([(id<SOGoMembershipSource>)(source) groupWithUIDHasMemberWithUID: currentUID memberUid: uid])
                     [acls addObject: [record valueForKey: @"c_role"]];
-                  else
-                    [self errorWithFormat: @"Group %@ has no member with UID %@", currentUID, uid];
                 }
               else
                 {
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoMailer.h sogo-5.2.0/SoObjects/SOGo/SOGoMailer.h
--- sogo-5.0.1/SoObjects/SOGo/SOGoMailer.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoMailer.h	2021-08-18 21:35:57.000000000 +0200
@@ -42,7 +42,7 @@
 + (SOGoMailer *) mailerWithDomainDefaults: (SOGoDomainDefaults *) dd;
 
 - (id) initWithDomainDefaults: (SOGoDomainDefaults *) dd;
-
+- (BOOL) requiresAuthentication;
 - (NSException *) sendMailData: (NSData *) data
 		  toRecipients: (NSArray *) recipients
 			sender: (NSString *) sender
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoMailer.m sogo-5.2.0/SoObjects/SOGo/SOGoMailer.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoMailer.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoMailer.m	2021-08-18 21:35:57.000000000 +0200
@@ -181,6 +181,11 @@
   [super dealloc];
 }
 
+- (BOOL) requiresAuthentication
+{
+  return ![mailingMechanism isEqualToString: @"sendmail"] && authenticationType;
+}
+
 - (NSException *) _sendmailSendData: (NSData *) mailData
 		       toRecipients: (NSArray *) recipients
 			     sender: (NSString *) sender
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoSAML2Session.m sogo-5.2.0/SoObjects/SOGo/SOGoSAML2Session.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoSAML2Session.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoSAML2Session.m	2021-08-18 21:35:57.000000000 +0200
@@ -24,7 +24,6 @@
 #include <lasso/xml/saml-2.0/saml2_attribute_value.h>
 #include <lasso/xml/saml-2.0/samlp2_authn_request.h>
 
-
 #import <NGObjWeb/WOApplication.h>
 #import <NGObjWeb/WOContext.h>
 
@@ -237,22 +236,24 @@
 
 - (void) _updateDataFromLogin
 {
-  LassoSaml2Assertion *saml2Assertion;
   GList *statementList, *attributeList;
-  LassoSaml2AttributeStatement *statement;
+  LassoMiscTextNode *textNode;
+  LassoNode *lassoNode;
+  LassoSaml2Assertion *saml2Assertion;
   LassoSaml2Attribute *attribute;
+  LassoSaml2AttributeStatement *statement;
   LassoSaml2AttributeValue *value;
-  LassoMiscTextNode *textNode;
   LassoSaml2NameID *nameIdentifier;
-  SOGoSystemDefaults *sd;
   NSString *loginAttribue;
+  SOGoSystemDefaults *sd;
   
   gchar *dump;
-                  
-  saml2Assertion = LASSO_SAML2_ASSERTION (lasso_login_get_assertion (lassoLogin));
+
+  lassoNode = lasso_login_get_assertion (lassoLogin);
+  saml2Assertion = LASSO_SAML2_ASSERTION (lassoNode);
   sd = [SOGoSystemDefaults sharedSystemDefaults];
   loginAttribue = [sd SAML2LoginAttribute];
-  
+
   if (saml2Assertion)
     {
       /* deduce user login */
@@ -267,6 +268,7 @@
           while (!login && attributeList)
             {
               attribute = LASSO_SAML2_ATTRIBUTE (attributeList->data);
+
               if (loginAttribue && (strcmp (attribute->Name, [loginAttribue UTF8String]) == 0))
                 {
                   value = LASSO_SAML2_ATTRIBUTE_VALUE (attribute->AttributeValue->data);
@@ -320,8 +322,7 @@
         assertion = nil;
     }
 
-  nameIdentifier
-    = LASSO_SAML2_NAME_ID (LASSO_PROFILE (lassoLogin)->nameIdentifier);
+  nameIdentifier = LASSO_SAML2_NAME_ID (LASSO_PROFILE (lassoLogin)->nameIdentifier);
   if (nameIdentifier)
     {
       /* deduce session id */
@@ -334,7 +335,7 @@
 - (id) _initWithDump: (NSDictionary *) saml2Dump
            inContext: (WOContext *) context
 {
-  // lasso_error_t rc;
+  lasso_error_t rc;
   LassoServer *server;
   LassoProfile *profile;
   const gchar *dump;
@@ -346,10 +347,10 @@
       if (saml2Dump)
         {
           profile = LASSO_PROFILE (lassoLogin);
+
           ASSIGN (login, [saml2Dump objectForKey: @"login"]);
           ASSIGN (identifier, [saml2Dump objectForKey: @"identifier"]);
           ASSIGN (assertion, [saml2Dump objectForKey: @"assertion"]);
-
           ASSIGN(identity, [saml2Dump objectForKey: @"identity"]);
           dump = [identity UTF8String];
           if (dump)
@@ -359,11 +360,10 @@
           dump = [session UTF8String];
           if (dump)
             lasso_profile_set_session_from_dump (profile, dump);
-          
-          lasso_login_accept_sso (lassoLogin);
-          // if (rc)
-          //   [NSException raiseSAML2Exception: rc];
-          [self _updateDataFromLogin];
+
+          rc = lasso_login_accept_sso (lassoLogin);
+          if (!rc)
+            [self _updateDataFromLogin];
         }
     }
 
@@ -454,7 +454,7 @@
 
   responseData = strdup ([authnResponse UTF8String]);
 
-  lasso_profile_set_signature_verify_hint(lassoLogin, LASSO_PROFILE_SIGNATURE_VERIFY_HINT_IGNORE);
+  profile = LASSO_PROFILE (lassoLogin);
   rc = lasso_login_process_authn_response_msg (lassoLogin, responseData);
   if (rc)
     [NSException raiseSAML2Exception: rc];
@@ -470,8 +470,6 @@
   [saml2Dump setObject: identifier forKey: @"identifier"];
   [saml2Dump setObject: assertion forKey: @"assertion"];
 
-  profile = LASSO_PROFILE (lassoLogin);
-
   lasso_session = lasso_profile_get_session (profile);
   if (lasso_session)
     {
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoSieveManager.m sogo-5.2.0/SoObjects/SOGo/SOGoSieveManager.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoSieveManager.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoSieveManager.m	2021-08-18 21:35:57.000000000 +0200
@@ -906,6 +906,8 @@
   if (!delimiter)
     [imapClient list: @"INBOX"  pattern: @""];
 
+  delimiter = [imapClient delimiter];
+
   if (!delimiter)
     delimiter = [dd stringForKey: @"NGImap4ConnectionStringSeparator"];
 
@@ -964,6 +966,9 @@
       text = [values objectForKey: @"autoReplyText"];
       b = YES;
 
+      if (!text)
+        text = @"";
+
       if (!useCustomSubject)
         {
           // If user has not specified a custom subject, fallback to the domain's defaults
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoSystemDefaults.h sogo-5.2.0/SoObjects/SOGo/SOGoSystemDefaults.h
--- sogo-5.0.1/SoObjects/SOGo/SOGoSystemDefaults.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoSystemDefaults.h	2021-08-18 21:35:57.000000000 +0200
@@ -1,6 +1,6 @@
 /* SOGoSystemDefaults.h - this file is part of SOGo
  *
- * Copyright (C) 2009-2016 Inverse inc.
+ * Copyright (C) 2009-2021 Inverse inc.
  *
  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -65,6 +65,7 @@
 
 - (BOOL) uixDebugEnabled;
 - (BOOL) easDebugEnabled;
+- (BOOL) tnefDecoderDebugEnabled;
 - (BOOL) xsrfValidationEnabled;
 
 - (NSString *) pageTitle;
@@ -112,6 +113,7 @@
 - (int) maximumSyncWindowSize;
 - (int) maximumSyncResponseSize;
 - (int) maximumPictureSize;
+- (BOOL) easSearchInBody;
 
 @end
 
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoSystemDefaults.m sogo-5.2.0/SoObjects/SOGo/SOGoSystemDefaults.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoSystemDefaults.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoSystemDefaults.m	2021-08-18 21:35:57.000000000 +0200
@@ -1,6 +1,6 @@
 /* SOGoSystemDefaults.m - this file is part of SOGo
  *
- * Copyright (C) 2009-2015 Inverse inc.
+ * Copyright (C) 2009-2021 Inverse inc.
  * Copyright (C) 2012 Jeroen Dekkers <jeroen@dekkers.ch>
  *
  * This file is free software; you can redistribute it and/or modify
@@ -434,6 +434,11 @@
   return [self boolForKey: @"SOGoEASDebugEnabled"];
 }
 
+- (BOOL) tnefDecoderDebugEnabled
+{
+  return [self boolForKey: @"SOGoTnefDecoderDebugEnabled"];
+}
+
 - (BOOL) xsrfValidationEnabled
 {
   id o;
@@ -730,6 +735,11 @@
   return v;
 }
 
+- (BOOL) easSearchInBody
+{
+  return [self boolForKey: @"SOGoEASSearchInBody"];
+}
+
 //
 // See https://msdn.microsoft.com/en-us/library/gg672032(v=exchg.80).aspx
 //
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoUserDefaults.h sogo-5.2.0/SoObjects/SOGo/SOGoUserDefaults.h
--- sogo-5.0.1/SoObjects/SOGo/SOGoUserDefaults.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoUserDefaults.h	2021-08-18 21:35:57.000000000 +0200
@@ -1,6 +1,6 @@
 /* SOGoUserDefaults.h - this file is part of SOGo
  *
- * Copyright (C) 2011-2020 Inverse inc.
+ * Copyright (C) 2011-2021 Inverse inc.
  *
  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -133,8 +133,8 @@
 - (void) setAnimationMode: (NSString *) newValue;
 - (NSString *) animationMode;
 
-- (BOOL) googleAuthenticatorEnabled;
-- (void) setGoogleAuthenticatorEnabled: (BOOL) newValue;
+- (BOOL) totpEnabled;
+- (void) setTotpEnabled: (BOOL) newValue;
 
 - (void) setMailComposeWindow: (NSString *) newValue;
 - (NSString *) mailComposeWindow;
@@ -185,6 +185,9 @@
 - (void) setMailIdentities: (NSArray *) newIdentites;
 - (NSArray *) mailIdentities;
 
+- (void) setMailForceDefaultIdentity: (BOOL) newValue;
+- (BOOL) mailForceDefaultIdentity;
+
 - (void) setAuxiliaryMailAccounts: (NSArray *) newAccounts;
 - (NSArray *) auxiliaryMailAccounts;
 
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoUserDefaults.m sogo-5.2.0/SoObjects/SOGo/SOGoUserDefaults.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoUserDefaults.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoUserDefaults.m	2021-08-18 21:35:57.000000000 +0200
@@ -1,6 +1,6 @@
 /* SOGoUserDefaults.m - this file is part of SOGo
  *
- * Copyright (C) 2009-2020 Inverse inc.
+ * Copyright (C) 2009-2021 Inverse inc.
  *
  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -228,6 +228,7 @@
                         @"SOGoReminderEnabled", @"ReminderEnabled",
                         @"SOGoReminderTime", @"ReminderTime",
                         @"SOGoRemindWithASound", @"RemindWithASound",
+                        @"SOGoTOTPEnabled", @"SOGoGoogleAuthenticatorEnabled",
                         nil];
       [migratedKeys retain];
     }
@@ -567,14 +568,14 @@
   return [self stringForKey: @"SOGoAnimationMode"];
 }
 
-- (BOOL) googleAuthenticatorEnabled
+- (BOOL) totpEnabled
 {
-  return [self boolForKey: @"SOGoGoogleAuthenticatorEnabled"];
+  return [self boolForKey: @"SOGoTOTPEnabled"];
 }
 
-- (void) setGoogleAuthenticatorEnabled: (BOOL) newValue
+- (void) setTotpEnabled: (BOOL) newValue
 {
-  [self setBool: newValue  forKey: @"SOGoGoogleAuthenticatorEnabled"];
+  [self setBool: newValue  forKey: @"SOGoTOTPEnabled"];
 }
 
 - (void) setMailComposeWindow: (NSString *) newValue
@@ -768,6 +769,16 @@
   return [self arrayForKey: @"SOGoMailIdentities"];
 }
 
+- (void) setMailForceDefaultIdentity: (BOOL) newValue
+{
+  [self setBool: newValue forKey: @"SOGoMailForceDefaultIdentity"];
+}
+
+- (BOOL) mailForceDefaultIdentity
+{
+  return [self boolForKey: @"SOGoMailForceDefaultIdentity"];
+}
+
 - (void) setAuxiliaryMailAccounts: (NSArray *) newAccounts
 {
   [self setObject: newAccounts forKey: @"AuxiliaryMailAccounts"];
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoUser.h sogo-5.2.0/SoObjects/SOGo/SOGoUser.h
--- sogo-5.0.1/SoObjects/SOGo/SOGoUser.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoUser.h	2021-08-18 21:35:57.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-  Copyright (C) 2006-2020 Inverse inc.
+  Copyright (C) 2006-2021 Inverse inc.
 
   This file is part of SOGo.
 
@@ -120,7 +120,7 @@
 
 - (BOOL) isSuperUser;
 - (BOOL) canAuthenticate;
-- (NSString *) googleAuthenticatorKey;
+- (NSString *) totpKey;
 
 /* resource */
 - (BOOL) isResource;
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoUser.m sogo-5.2.0/SoObjects/SOGo/SOGoUser.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoUser.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoUser.m	2021-08-18 21:35:57.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-  Copyright (C) 2006-2020 Inverse inc.
+  Copyright (C) 2006-2021 Inverse inc.
 
   This file is part of SOGo.
 
@@ -884,6 +884,9 @@
   [mailAccount setObject: identities forKey: @"identities"];
   [identities release];
 
+  if ([_defaults mailForceDefaultIdentity])
+    [mailAccount setObject: [NSNumber numberWithBool: YES] forKey: @"forceDefaultIdentity"];
+
   // 6. Receipts
   if ([_defaults allowUserReceipt])
     {
@@ -942,7 +945,7 @@
   [mailAccount setObject: delegates  forKey: @"delegates"];
 
   // 9. Security
-  if ([[_defaults mailCertificate] length])
+  if ([[self domainDefaults] mailCertificateEnabled] && [[_defaults mailCertificate] length])
     {
       security = [NSMutableDictionary new];
 
@@ -1126,7 +1129,7 @@
   return [authValue boolValue];
 }
 
-- (NSString *) googleAuthenticatorKey
+- (NSString *) totpKey
 {
 #if defined(MFA_CONFIG)
   NSString *key, *result;
diff -Nru sogo-5.0.1/SoObjects/SOGo/SOGoUserManager.m sogo-5.2.0/SoObjects/SOGo/SOGoUserManager.m
--- sogo-5.0.1/SoObjects/SOGo/SOGoUserManager.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/SOGoUserManager.m	2021-08-18 21:35:57.000000000 +0200
@@ -293,10 +293,8 @@
 
   if (!domain) return NO;
 
-  ids = [_sources allKeys];
+  ids = [[SOGoSystemDefaults sharedSystemDefaults] domainIds];
   if ([ids containsObject: domain])
-    // FIXME check SOGoMailDomain?
-    // Now source id is being considered as the domain
     return YES;
 
   sd = [SOGoSystemDefaults sharedSystemDefaults];
@@ -433,15 +431,18 @@
                            perr: (SOGoPasswordPolicyError *) perr
 {
   NSObject <SOGoSource> *sogoSource;
-  NSEnumerator *authIDs;
   NSString *currentID;
   BOOL didChange;
 
+  *perr = -1;
   didChange = NO;
 
-  authIDs = [[self authenticationSourceIDsInDomain: domain] objectEnumerator];
-  while (!didChange && (currentID = [authIDs nextObject]))
+  NSDictionary *info = [self contactInfosForUserWithUIDorEmail: login
+                                                      inDomain: domain];
+
+  if (info)
     {
+      currentID = [info objectForKey: @"SOGoSource"];
       sogoSource = [_sources objectForKey: currentID];
       didChange = [sogoSource changePasswordForLogin: login
                                          oldPassword: oldPassword
@@ -544,7 +545,7 @@
 
   username = _login;
 
-  if (*_domain)
+  if (*_domain && ![*_domain isKindOfClass: NSNullK])
     {
       if ([_login rangeOfString: @"@"].location == NSNotFound)
         username = [NSString stringWithFormat: @"%@@%@", _login, *_domain];
@@ -557,6 +558,7 @@
       // sources if SOGoLoginDomains isn't specified. This is also true if the user is
       // using DAV or EAS.
       r = [username rangeOfString: @"@"];
+      *_domain = nil;
 
       if (r.location != NSNotFound)
         {
@@ -1020,7 +1022,7 @@
     {
       // Remove the "@" prefix used to identified groups in the ACL tables.
       aUID = [uid hasPrefix: @"@"] ? [uid substringFromIndex: 1] : uid;
-      if (domain && [aUID rangeOfString: @"@"].location == NSNotFound)
+      if ([domain length] && [aUID rangeOfString: @"@"].location == NSNotFound)
         cacheUid = [NSString stringWithFormat: @"%@@%@", aUID, domain];
       else
         cacheUid = aUID;
@@ -1031,7 +1033,7 @@
       if ([currentUser isKindOfClass: NSNullK])
         currentUser = nil;
       else if (!([currentUser objectForKey: @"emails"]
-            && [currentUser objectForKey: @"cn"]))
+                 && [currentUser objectForKey: @"cn"]))
         {
           // We make sure that we either have no occurence of a cache entry or
           // that we have an occurence with only a cached password. In the
diff -Nru sogo-5.0.1/SoObjects/SOGo/WORequest+SOGo.m sogo-5.2.0/SoObjects/SOGo/WORequest+SOGo.m
--- sogo-5.0.1/SoObjects/SOGo/WORequest+SOGo.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/WORequest+SOGo.m	2021-08-18 21:35:57.000000000 +0200
@@ -127,6 +127,7 @@
 
 //
 // Mac+OS+X/10.10.1 (14B25) CalendarAgent/315
+// macOS/11.0.1 (20B50) CalendarAgent/954
 //
 - (BOOL) isICal
 {
@@ -137,6 +138,7 @@
   return ([self isAppleDAVWithSubstring: @"Mac OS X/10."]
           || [self isAppleDAVWithSubstring: @"Mac_OS_X/"]
           || [self isAppleDAVWithSubstring: @"Mac+OS+X/"]
+          || [self isAppleDAVWithSubstring: @"macOS/"]
           || [self isAppleDAVWithSubstring: @"CoreDAV/"]
           || [[cc userAgent] rangeOfString: @"DAVx5"].location != NSNotFound);
 }
@@ -147,6 +149,7 @@
 // Mac OS X/10.8 (12A269) Calendar/1639
 // Mac OS X/10.8 (12A269) CalendarAgent/47
 // Mac OS X/10.8.1 (12B19) CalendarAgent/47
+// macOS/11.0.1 (20B50) CalendarAgent/954
 //
 - (BOOL) isICal4
 {
@@ -175,6 +178,18 @@
 // Mac OS X/10.8.1 (12B19) AddressBook/1143
 // Mac OS X/10.8.2 (12C60) AddressBook/1167
 //
+// For 10.14, we see:
+//
+// Mac OS X/10.14.6 (18G6042) AddressBookCore/1
+//
+// For 10.15, we see:
+//
+// Mac OS X/10.15.7 (19H1030) AddressBookCore/1
+//
+// For 11.0, we see:
+//
+// macOS/11.0.1 (20B50) AddressBookCore/2452
+//
 - (BOOL) isMacOSXAddressBookApp
 {
   WEClientCapabilities *cc;
@@ -197,7 +212,12 @@
           [[cc userAgent] rangeOfString: @"Mac OS X"].location != NSNotFound
           && [[cc userAgent] rangeOfString: @"AddressBook"].location != NSNotFound
         )
-      );
+        ||
+        (
+          [[cc userAgent] rangeOfString: @"macOS"].location != NSNotFound
+          && [[cc userAgent] rangeOfString: @"AddressBookCore"].location != NSNotFound
+         )
+       );
 
   return b;
 }
@@ -209,7 +229,7 @@
   cc = [self clientCapabilities];
 
   return ([[cc userAgent] rangeOfString: @"DataAccess/1.0"].location != NSNotFound ||
-          [[cc userAgent] rangeOfString: @"dataaccessd/1.0"].location != NSNotFound); // Seen on iOS 5.0.1 on iPad
+          [[cc userAgent] rangeOfString: @"dataaccessd/1.0"].location != NSNotFound); // Since iOS 5.0.1
 }
 
 - (BOOL) isAndroid
diff -Nru sogo-5.0.1/SOPE/GDLContentStore/GCSAlarmsFolder.m sogo-5.2.0/SOPE/GDLContentStore/GCSAlarmsFolder.m
--- sogo-5.0.1/SOPE/GDLContentStore/GCSAlarmsFolder.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/GDLContentStore/GCSAlarmsFolder.m	2021-08-18 21:35:57.000000000 +0200
@@ -163,7 +163,7 @@
 
 - (void) _releaseChannel: (EOAdaptorChannel *) _channel
 {
-  [[self _channelManager] releaseChannel:_channel];
+  [[self _channelManager] releaseChannel:_channel  immediately: YES];
 }
 
 - (BOOL) canConnectStore
diff -Nru sogo-5.0.1/SOPE/GDLContentStore/GCSChannelManager.h sogo-5.2.0/SOPE/GDLContentStore/GCSChannelManager.h
--- sogo-5.0.1/SOPE/GDLContentStore/GCSChannelManager.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/GDLContentStore/GCSChannelManager.h	2021-08-18 21:35:57.000000000 +0200
@@ -51,6 +51,7 @@
 - (void)releaseChannel:(EOAdaptorChannel *)_channel;
 - (void)releaseChannel:(EOAdaptorChannel *)_channel
            immediately:(BOOL)_immediately;
+- (void) releaseAllChannels;
 
 /* checking for tables */
 
diff -Nru sogo-5.0.1/SOPE/GDLContentStore/GCSChannelManager.m sogo-5.2.0/SOPE/GDLContentStore/GCSChannelManager.m
--- sogo-5.0.1/SOPE/GDLContentStore/GCSChannelManager.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/GDLContentStore/GCSChannelManager.m	2021-08-18 21:35:57.000000000 +0200
@@ -399,6 +399,27 @@
     }
 }
 
+- (void) releaseAllChannels
+{
+  EOAdaptorChannel *channel;
+  GCSChannelHandle *handle;
+  NSEnumerator *e;
+
+  e = [busyChannels objectEnumerator];
+  while ((handle = [e nextObject]))
+    {
+      [handle retain];
+      ASSIGN (handle->lastReleaseTime, [NSCalendarDate date]);
+      [busyChannels removeObject: handle];
+      channel = [handle channel];
+      if (debugPools)
+        [self logWithFormat: @"releaseAllChannels: freeing old channel (age %ds, %p) ", (int)[handle age], channel];
+      if ([channel isOpen])
+	[channel closeChannel];
+      [handle release];
+    }
+}
+
 /* checking for tables */
 
 - (BOOL) canConnect: (NSURL *) _url
diff -Nru sogo-5.0.1/SOPE/GDLContentStore/GCSFolder.m sogo-5.2.0/SOPE/GDLContentStore/GCSFolder.m
--- sogo-5.0.1/SOPE/GDLContentStore/GCSFolder.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/GDLContentStore/GCSFolder.m	2021-08-18 21:35:57.000000000 +0200
@@ -457,7 +457,7 @@
 
   field = [qualifier key];
   attribute = [self _attributeForColumn: field];
-  if (attribute)
+  if (attribute && [[qualifier value] isNotNull])
     {
       formattedValue = [adaptor formatValue: [qualifier value]
                                forAttribute: attribute];
diff -Nru sogo-5.0.1/SOPE/NGCards/iCalCalendar.m sogo-5.2.0/SOPE/NGCards/iCalCalendar.m
--- sogo-5.0.1/SOPE/NGCards/iCalCalendar.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/iCalCalendar.m	2021-08-18 21:35:57.000000000 +0200
@@ -22,6 +22,8 @@
 #import <Foundation/NSArray.h>
 #import <Foundation/NSString.h>
 
+#import <NGExtensions/NSObject+Logs.h>
+
 #import "iCalEvent.h"
 #import "iCalToDo.h"
 #import "iCalJournal.h"
@@ -39,6 +41,30 @@
 
 @implementation iCalCalendar
 
++ (NSArray *) parseFromSource: (id) source
+{
+  NSArray *result;
+  NSMutableString *content;
+
+  result = [super parseFromSource: source];
+
+  // If parsing doesn't return any card, check if the opening tag is present but the ending tag
+  // missing. Add the ending tag and parse the source again in this case.
+  if ([result count] == 0 &&
+      [source length] &&
+      [source hasPrefix: @"BEGIN:VCALENDAR"] &&
+      !([source hasSuffix: @"END:VCALENDAR\r\n"] || [source hasSuffix: @"END:VCALENDAR"]))
+    {
+      content = [NSMutableString stringWithString: source];
+      [content appendString: @"END:VCALENDAR"];
+      result = [super parseFromSource: content];
+      if ([result count] > 0)
+        [self logWithFormat: @"Successfully repaired VCALENDAR by adding ending tag"];
+    }
+
+  return result;
+}
+
 /* class mapping */
 - (Class) classForTag: (NSString *) classTag
 {
diff -Nru sogo-5.0.1/SOPE/NGCards/NGVList.m sogo-5.2.0/SOPE/NGCards/NGVList.m
--- sogo-5.0.1/SOPE/NGCards/NGVList.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/NGVList.m	2021-08-18 21:35:57.000000000 +0200
@@ -179,12 +179,12 @@
   NSMutableArray *deletedRefs;
 
   deletedRefs = [NSMutableArray array];
-  cardReferences
-    = [[self childrenWithTag: @"card"] objectEnumerator];
+  cardReferences = [[self childrenWithTag: @"card"] objectEnumerator];
   while ((currentRef = [cardReferences nextObject]))
-    if ([[currentRef reference]
-	  isEqualToString: [cardRef reference]])
-      [deletedRefs addObject: currentRef];
+    {
+      if ([[currentRef reference] isEqualToString: [cardRef reference]])
+        [deletedRefs addObject: currentRef];
+    }
 
   [children removeObjectsInArray: deletedRefs];
 }
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Abidjan.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Abidjan.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Abidjan.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Abidjan.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Abidjan
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Abidjan
 BEGIN:STANDARD
 TZNAME:GMT
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Accra.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Accra.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Accra.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Accra.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Accra
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Accra
 BEGIN:STANDARD
 TZNAME:GMT
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Algiers.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Algiers.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Algiers.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Algiers.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Algiers
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Algiers
 BEGIN:STANDARD
 TZNAME:CET
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Bissau.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Bissau.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Bissau.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Bissau.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Bissau
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Bissau
 BEGIN:STANDARD
 TZNAME:GMT
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Cairo.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Cairo.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Cairo.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Cairo.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Cairo
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Cairo
 BEGIN:STANDARD
 TZNAME:EET
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Casablanca.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Casablanca.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Casablanca.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Casablanca.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,10 +1,10 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Casablanca
-TZUNTIL:20870504T020001Z
-LAST-MODIFIED:20191023T183904Z
+TZUNTIL:20870511T020001Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Casablanca
 BEGIN:STANDARD
 TZNAME:+01
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Ceuta.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Ceuta.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Ceuta.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Ceuta.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Ceuta
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135712Z
 X-LIC-LOCATION:Africa/Ceuta
 BEGIN:DAYLIGHT
 TZNAME:CEST
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/El_Aaiun.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/El_Aaiun.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/El_Aaiun.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/El_Aaiun.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,10 +1,10 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/El_Aaiun
-TZUNTIL:20870504T020001Z
-LAST-MODIFIED:20191023T183904Z
+TZUNTIL:20870511T020001Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/El_Aaiun
 BEGIN:STANDARD
 TZNAME:+01
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Johannesburg.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Johannesburg.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Johannesburg.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Johannesburg.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Johannesburg
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Johannesburg
 BEGIN:STANDARD
 TZNAME:SAST
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Juba.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Juba.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Juba.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Juba.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,14 +1,14 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Juba
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Juba
 BEGIN:STANDARD
-TZNAME:EAT
-TZOFFSETFROM:+0300
-TZOFFSETTO:+0300
+TZNAME:CAT
+TZOFFSETFROM:+0200
+TZOFFSETTO:+0200
 DTSTART:19700101T000000
 END:STANDARD
 END:VTIMEZONE
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Khartoum.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Khartoum.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Khartoum.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Khartoum.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Khartoum
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Khartoum
 BEGIN:STANDARD
 TZNAME:CAT
diff -Nru sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Lagos.ics sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Lagos.ics
--- sogo-5.0.1/SOPE/NGCards/TimeZones/Africa/Lagos.ics	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SOPE/NGCards/TimeZones/Africa/Lagos.ics	2021-08-18 21:35:57.000000000 +0200
@@ -1,9 +1,9 @@
 BEGIN:VCALENDAR
-PRODID:-//Inverse inc.//NONSGML IANA 2019c//EN
+PRODID:-//Inverse inc.//NONSGML IANA 2021a//EN
 VERSION:2.0
 BEGIN:VTIMEZONE
 TZID:Africa/Lagos
-LAST-MODIFIED:20191023T183904Z
+LAST-MODIFIED:20210303T135711Z
 X-LIC-LOCATION:Africa/Lagos
 BEGIN:STANDARD
 TZNAME:WAT
